/*
    ZEsarUX  ZX Second-Emulator And Released for UniX 
    Copyright (C) 2013 Cesar Hernandez Bano

    This file is part of ZEsarUX.

    ZEsarUX is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MENU_H
#define MENU_H

#include "cpu.h"

extern int menu_overlay_activo;
extern void (*menu_overlay_function)(void);

extern char *esc_key_message;
extern char *openmenu_key_message;


extern void set_menu_overlay_function(void (*funcion)(void) );
extern void reset_menu_overlay_function(void);
extern void pruebas_texto_menu(void);
extern void cls_menu_overlay(void);
extern void menu_escribe_texto(z80_byte x,z80_byte y,z80_byte tinta,z80_byte papel,char *texto);
extern void normal_overlay_texto_menu(void);
//extern int menu_second_layer;
extern int menu_footer;
//extern int menu_second_layer_counter;
//extern void enable_second_layer(void);
//extern void disable_second_layer(void);
extern void enable_footer(void);
extern void disable_footer(void);
extern void menu_init_footer(void);
extern void menu_footer_z88(void);

struct s_overlay_screen {
	z80_byte tinta,papel;
	z80_byte caracter;
};

typedef struct s_overlay_screen overlay_screen;

extern overlay_screen overlay_screen_array[];
//extern overlay_screen second_overlay_screen_array[];

//Posiciones de texto mostrado en second overlay
#define WINDOW_FOOTER_ELEMENT_X_JOYSTICK 0
#define WINDOW_FOOTER_ELEMENT_X_FPS 0
#define WINDOW_FOOTER_ELEMENT_X_PRINTING 10
#define WINDOW_FOOTER_ELEMENT_X_FLASH_ZXUNO 10
#define WINDOW_FOOTER_ELEMENT_X_MMC 11
#define WINDOW_FOOTER_ELEMENT_X_TEXT_FILTER 10
#define WINDOW_FOOTER_ELEMENT_X_ZXPAND 10
#define WINDOW_FOOTER_ELEMENT_X_TAPE 11
#define WINDOW_FOOTER_ELEMENT_X_FLAP 11
#define WINDOW_FOOTER_ELEMENT_X_CPU_TEMP 19
#define WINDOW_FOOTER_ELEMENT_X_CPU_USE 25
#define WINDOW_FOOTER_ELEMENT_X_BATERIA 30

#define WINDOW_FOOTER_ELEMENT_Y_CPU_USE 1
#define WINDOW_FOOTER_ELEMENT_Y_CPU_TEMP 1
#define WINDOW_FOOTER_ELEMENT_Y_FPS 1


/*

Como quedan los textos:

01234567890123456789012345678901
50 FPS    -PRINT-  29.3C 100% BAT 
           -TAPE-
          -FLASH-
          -SPEECH-
	   MMC
          -ZXPAND-
*/



extern void putchar_menu_overlay(int x,int y,z80_byte caracter,z80_byte tinta,z80_byte papel);
//extern void putchar_menu_second_overlay(int x,int y,z80_byte caracter,z80_byte tinta,z80_byte papel);
extern void menu_putchar_footer(int x,int y,z80_byte caracter,z80_byte tinta,z80_byte papel);
extern void menu_putstring_footer(int x,int y,char *texto,z80_byte tinta,z80_byte papel);
extern void cls_menu_overlay(void);
extern int menu_multitarea;
extern int menu_abierto;

extern int if_pending_error_message;
extern char pending_error_message[];


extern void menu_inicio(void);

extern void set_splash_text(void);
extern void reset_splash_text(void);
extern z80_bit menu_splash_text_active;
extern int menu_splash_segundos;
extern z80_byte menu_da_todas_teclas(void);
extern void menu_espera_tecla_o_joystick(void);
extern void menu_espera_no_tecla(void);
extern void menu_get_dir(char *ruta,char *directorio);

extern int menu_tooltip_counter;

extern z80_bit tooltip_enabled;

extern char *quickfile;
extern char quickload_file[];

extern z80_bit menu_button_quickload;
extern z80_bit menu_button_exit_emulator;

extern int menu_contador_teclas_repeticion;
extern int menu_segundo_contador_teclas_repeticion;

extern int menu_speech_tecla_pulsada;

extern char binary_file_load[];

extern char menu_buffer_textspeech_filter_program[];

extern char menu_buffer_textspeech_stop_filter_program[];

extern void screen_print_splash_text(z80_byte y,z80_byte tinta,z80_byte papel,char *texto);

extern char menu_realtape_name[];

extern z80_bit menu_force_writing_inverse_color;

extern void menu_filesel_chdir(char *dir);

extern void draw_footer(void);

#endif
